"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DetailedVersion = exports.SimpleVersion = void 0;
const react_1 = __importDefault(require("react"));
const design_ui_styles_ellipsis_1 = require("@teambit/design.ui.styles.ellipsis");
const classnames_1 = __importDefault(require("classnames"));
const semver = __importStar(require("semver"));
const evangelist_elements_icon_1 = require("@teambit/evangelist.elements.icon");
const design_ui_time_ago_1 = require("@teambit/design.ui.time-ago");
const design_ui_avatar_1 = require("@teambit/design.ui.avatar");
const base_ui_loaders_skeleton_1 = require("@teambit/base-ui.loaders.skeleton");
const version_dropdown_placeholder_module_scss_1 = __importDefault(require("./version-dropdown-placeholder.module.scss"));
function SimpleVersion(_a) {
    var { currentVersion, className, disabled, hasMoreVersions, isTag = (version) => semver.valid(version) !== null, 
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    useCurrentVersionLog, showFullVersion, loading } = _a, rest = __rest(_a, ["currentVersion", "className", "disabled", "hasMoreVersions", "isTag", "useCurrentVersionLog", "showFullVersion", "loading"]);
    if (loading)
        return react_1.default.createElement(base_ui_loaders_skeleton_1.WordSkeleton, { className: version_dropdown_placeholder_module_scss_1.default.loader, length: 9 });
    const formattedVersion = showFullVersion || isTag(currentVersion) ? currentVersion : currentVersion === null || currentVersion === void 0 ? void 0 : currentVersion.slice(0, 6);
    return (react_1.default.createElement("div", Object.assign({}, rest, { className: (0, classnames_1.default)(version_dropdown_placeholder_module_scss_1.default.simple, className, disabled && version_dropdown_placeholder_module_scss_1.default.disabled) }),
        react_1.default.createElement(design_ui_styles_ellipsis_1.Ellipsis, { className: (0, classnames_1.default)(version_dropdown_placeholder_module_scss_1.default.versionName), onClick: rest.onClick }, formattedVersion),
        hasMoreVersions && react_1.default.createElement(evangelist_elements_icon_1.Icon, { of: "fat-arrow-down", onClick: rest.onClick })));
}
exports.SimpleVersion = SimpleVersion;
function DetailedVersion(_a) {
    var { currentVersion, className, disabled, hasMoreVersions, isTag = (version) => semver.valid(version) !== null, loading, useCurrentVersionLog, showFullVersion } = _a, rest = __rest(_a, ["currentVersion", "className", "disabled", "hasMoreVersions", "isTag", "loading", "useCurrentVersionLog", "showFullVersion"]);
    const currentVersionLog = useCurrentVersionLog === null || useCurrentVersionLog === void 0 ? void 0 : useCurrentVersionLog({ skip: loading, version: currentVersion });
    const { displayName, message, username, email, date: _date, profileImage } = currentVersionLog || {};
    const author = react_1.default.useMemo(() => {
        return {
            displayName: displayName !== null && displayName !== void 0 ? displayName : '',
            email,
            name: username !== null && username !== void 0 ? username : '',
            profileImage,
        };
    }, [displayName, email, username, profileImage]);
    const formattedVersion = showFullVersion || isTag(currentVersion) ? currentVersion : currentVersion === null || currentVersion === void 0 ? void 0 : currentVersion.slice(0, 6);
    const date = _date ? new Date(+_date) : undefined;
    const timestamp = react_1.default.useMemo(() => (date ? new Date(+date).toString() : new Date().toString()), [date]);
    if (loading)
        return react_1.default.createElement(base_ui_loaders_skeleton_1.WordSkeleton, { className: version_dropdown_placeholder_module_scss_1.default.loader, length: 9 });
    return (react_1.default.createElement("div", Object.assign({}, rest, { className: (0, classnames_1.default)(version_dropdown_placeholder_module_scss_1.default.detailed, className, disabled && version_dropdown_placeholder_module_scss_1.default.disabled) }),
        react_1.default.createElement(design_ui_avatar_1.UserAvatar, { size: 24, account: author !== null && author !== void 0 ? author : {}, className: version_dropdown_placeholder_module_scss_1.default.versionUserAvatar, showTooltip: true, onClick: rest.onClick }),
        react_1.default.createElement(design_ui_styles_ellipsis_1.Ellipsis, { className: (0, classnames_1.default)(version_dropdown_placeholder_module_scss_1.default.versionName), onClick: rest.onClick }, formattedVersion),
        commitMessage(message, rest.onClick),
        react_1.default.createElement(design_ui_styles_ellipsis_1.Ellipsis, { className: version_dropdown_placeholder_module_scss_1.default.versionTimestamp, onClick: rest.onClick },
            react_1.default.createElement(design_ui_time_ago_1.TimeAgo, { date: timestamp, onClick: rest.onClick })),
        hasMoreVersions && react_1.default.createElement(evangelist_elements_icon_1.Icon, { of: "fat-arrow-down", onClick: rest.onClick })));
}
exports.DetailedVersion = DetailedVersion;
function commitMessage(message, onClick) {
    if (!message || message === '')
        return (react_1.default.createElement(design_ui_styles_ellipsis_1.Ellipsis, { className: version_dropdown_placeholder_module_scss_1.default.emptyMessage, onClick: onClick }, "No commit message"));
    return (react_1.default.createElement(design_ui_styles_ellipsis_1.Ellipsis, { className: version_dropdown_placeholder_module_scss_1.default.commitMessage, onClick: onClick }, message));
}
//# sourceMappingURL=version-dropdown-placeholder.js.map